package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.PengambilanOvum;
import com.jasamedika.medifirst2000.vo.PengambilanOvumVO;

@Component
public class PengambilanOvumConverter implements BaseVoConverter<PengambilanOvumVO, PengambilanOvum> {

	@Override
	public PengambilanOvum transferVOToModel(PengambilanOvumVO vo, PengambilanOvum model) {
		if (null == model)
			model = new PengambilanOvum();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, PengambilanOvum.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;
	}

	@Override
	public List<PengambilanOvumVO> transferListOfModelToListOfVO(List<PengambilanOvum> models,
			List<PengambilanOvumVO> vos) {
		if (null == vos)
			vos = new ArrayList<PengambilanOvumVO>();

		if (null == models)
			return vos;

		for (PengambilanOvum pengambilanOvum : models) {
			PengambilanOvumVO vo = new PengambilanOvumVO();
			vo=transferModelToVO(pengambilanOvum, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public PengambilanOvumVO transferModelToVO(PengambilanOvum model, PengambilanOvumVO vo) {
		if (null == vo)
			vo = new PengambilanOvumVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, PengambilanOvumVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}

}
